close all;clear all
gr=groot;gr.ShowHiddenHandles='on';
fig=uifigure;
sub22(1)=uiaxes(fig);
sub22(2)=uiaxes(fig);
sub22(3)=uiaxes(fig);
sub22(4)=uiaxes(fig);
set(sub22(1),'Units','normalized','Position',[0.1300 0.5838 0.3347 0.3412])
set(sub22(2),'Units','normalized','Position',[0.5703 0.5838 0.3347 0.3412])
set(sub22(3),'Units','normalized','Position',[0.1300 0.1100 0.3347 0.3412])
set(sub22(4),'Units','normalized','Position',[0.5703 0.1100 0.3347 0.3412])
viewagl=[-37.5,30;0,90;90,0;0,0];

n=21;
l=[zeros(2,n);ones(1,n)];

arm( 1).l=[0;0;6];	arm( 1).a=[0;1;0];	arm( 1).limit=[-pi/4, pi/4];	arm(1).label='手首(左右)';
arm( 2).l=[0;0;0];	arm( 2).a=[1;0;0];	arm( 2).limit=[-pi/4, pi/2];	arm(2).label='手首(前後)';
arm( 1).th=0;   arm( 1).parent=0;
arm( 2).th=0;   arm( 2).parent=1;

% <指>
% 親指
arm( 3).l=[-4;0;5];	    arm( 3).a=[1;1;1];		arm( 3).label='親指0';
arm( 4).l=[-2;0;3.5];	arm( 4).a=[1;1;0];	    arm( 4).label='親指1';
arm( 5).l=[-1;0;2.5];	arm( 5).a=[1;0;0];	    arm( 5).label='親指2';
% 人差し指
arm( 6).l=[-2.5;0;9.5];	arm( 6).a=[1;0;0];		arm( 6).label='人差し指0';
arm( 7).l=[0;0;3.2];	arm( 7).a=[1;0;0];		arm( 7).label='人差し指1';
arm( 8).l=[0;0;2.4];	arm( 8).a=[1;0;0];		arm( 8).label='人差し指2';
arm( 9).l=[0;0;1.6];	arm( 9).a=[1;0;0];		arm( 9).label='人差し指3';
% 中指
arm(10).l=[0;0;10];	    arm(10).a=[1;0;0];		arm(10).label='中指0';
arm(11).l=[0;0;4];		arm(11).a=[1;0;0];		arm(11).label='中指1';
arm(12).l=[0;0;3];		arm(12).a=[1;0;0];		arm(12).label='中指2';
arm(13).l=[0;0;2];		arm(13).a=[1;0;0];		arm(13).label='中指3';
%薬指
arm(14).l=[2.5;0;9.5];	arm(14).a=[1;0;0];	    arm(14).label='薬指0';
arm(15).l=[0;0;3.2];	arm(15).a=[1;0;0];	    arm(15).label='薬指1';
arm(16).l=[0;0;2.4];	arm(16).a=[1;0;0];	    arm(16).label='薬指2';
arm(17).l=[0;0;1.6];	arm(17).a=[1;0;0];	    arm(17).label='薬指3';
%小指
arm(18).l=[4.5;0;8.5];  arm(18).a=[1;0;0];	    arm(18).label='小指0';
arm(19).l=[0;0;2];	    arm(19).a=[1;0;0];	    arm(19).label='小指1';
arm(20).l=[0;0;1.7];	arm(20).a=[1;0;0];	    arm(20).label='小指2';
arm(21).l=[0;0;1.7];	arm(21).a=[1;0;0];	    arm(21).label='小指3';
for i=3:21
	arm(i).th=0;
	arm(i).limit=[0, pi/2];
	if any(i == [3,6,10,14,18])
		arm(i).parent=2;
    else
		arm(i).parent=i-1;
	end
end

for i=1:21
    arm(i).l=arm(i).l/10;
    arm(i).lg=arm(i).l/2;
end


% 子リンクを接続し双方向リンクとする。
arm=vectest9makechildlink(arm);

ind=vectest9findallchildren(arm);
arm=vectest9kinematics(arm,ind);
plot1=[];
plot1=vectest9plot2021(arm,plot1,sub22);

fig2=uifigure;fig2.Position = [900 250 430 430];
[ui, buttons]=vectest9makeui2021(arm,'vectest9sub2021;',fig2);

for i=1:4
	axis(sub22(i),'equal');
    axis(sub22(i),[-2,2,-2,2,-1,3]);
	view(sub22(i),viewagl(i,:));grid(sub22(i),'on');
end


